// cube class
// -Kyoung Shin Park (2010 Spring)
//////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <GL/glu.h>
#include <GL/gl.h>
#include "cube.h"

namespace oglclass
{

cube::cube()
{
	cubeType_ = CUBE_WIREFRAME;
	makeCube();
}

cube::~cube()
{
}

void cube::makeCube(float w, float h, float l)
{
	width_ = w; height_ = h; length_ = l;

	vertexCoord_[0][0] = width_/2; vertexCoord_[0][1] = height_/2; vertexCoord_[0][2] = length_/2; 
	vertexCoord_[1][0] = width_/2; vertexCoord_[1][1] = -height_/2; vertexCoord_[1][2] = length_/2; 
	vertexCoord_[2][0] = width_/2; vertexCoord_[2][1] = -height_/2; vertexCoord_[2][2] = -length_/2; 
	vertexCoord_[3][0] = width_/2; vertexCoord_[3][1] = height_/2; vertexCoord_[3][2] = -length_/2; 
	vertexCoord_[4][0] =  -width_/2; vertexCoord_[4][1] = height_/2; vertexCoord_[4][2] = length_/2; 
	vertexCoord_[5][0] =  -width_/2; vertexCoord_[5][1] = -height_/2; vertexCoord_[5][2] = length_/2; 
	vertexCoord_[6][0] =  -width_/2; vertexCoord_[6][1] = -height_/2; vertexCoord_[6][2] = -length_/2; 
	vertexCoord_[7][0] =  -width_/2; vertexCoord_[7][1] = height_/2; vertexCoord_[7][2] = -length_/2; 

	index_[0][0] = 0;index_[0][1] = 1;index_[0][2] = 2;index_[0][3] = 3;
	index_[1][0] = 0;index_[1][1] = 4;index_[1][2] = 5;index_[1][3] = 1;
	index_[2][0] = 4;index_[2][1] = 7;index_[2][2] = 6;index_[2][3] = 5;
	index_[3][0] = 7;index_[3][1] = 3;index_[3][2] = 2;index_[3][3] = 6;
	index_[4][0] = 0;index_[4][1] = 3;index_[4][2] = 7;index_[4][3] = 4;
	index_[5][0] = 1;index_[5][1] = 5;index_[5][2] = 6;index_[5][3] = 2;

	normalCoord_[0][0] =  1.0; normalCoord_[0][1] =  0.0; normalCoord_[0][2] =  0.0;
	normalCoord_[1][0] =  0.0; normalCoord_[1][1] =  1.0; normalCoord_[1][2] =  0.0;
	normalCoord_[2][0] =  0.0; normalCoord_[2][1] =  0.0; normalCoord_[2][2] =  1.0;
	normalCoord_[3][0] = -1.0; normalCoord_[3][1] =  0.0; normalCoord_[3][2] =  0.0;
	normalCoord_[4][0] =  0.0; normalCoord_[4][1] = -1.0; normalCoord_[4][2] =  0.0;
	normalCoord_[5][0] =  0.0; normalCoord_[5][1] =  0.0; normalCoord_[5][2] = -1.0;

	textureCoord_[0][0] = 1.0; textureCoord_[0][1] = 1.0; 
	textureCoord_[1][0] = 0.0; textureCoord_[1][1] = 1.0; 
	textureCoord_[2][0] = 0.0; textureCoord_[2][1] = 0.0; 
	textureCoord_[3][0] = 1.0; textureCoord_[3][1] = 0.0; 
}

void cube::draw()
{
	// enable blending
	if ((cubeType_ == CUBE_TRANSPARENT) || (cubeType_ == CUBE_TEXTURE_TRANSPARENT)) {
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 
	}

	for(int i = 0; i < 6; i++) {
		if (cubeType_ == CUBE_WIREFRAME)
			glBegin(GL_LINE_LOOP);	// GL_LINE_LOOP for wireframe drawmode
		else
			glBegin(GL_POLYGON);	// otherwise, use polygon drawmode
		glNormal3fv(normalCoord_[i]);
		for(int j = 0; j < 4; j++) {
			glTexCoord2fv(textureCoord_[j]);		// set texture coordinates
			glVertex3fv(vertexCoord_[index_[i][j]]);// set vertex coordinates
		}
		glEnd();
	}

	// disable blending
	if ((cubeType_ == CUBE_TRANSPARENT) || (cubeType_ == CUBE_TEXTURE_TRANSPARENT))
		glDisable(GL_BLEND);
}

} // namespace