// cube class
// -Kyoung Shin Park (2010 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __CUBE_H__
#define __CUBE_H__

#include "node.h"

namespace oglclass
{
enum cubeType {CUBE_WIREFRAME, CUBE_SOLID, CUBE_TRANSPARENT, CUBE_TEXTURE, CUBE_TEXTURE_TRANSPARENT};

class cube : public node
{
public:
	cube(void);
	virtual ~cube(void);
	virtual void draw();

	void makeCube(float w=1.0, float h=1.0, float l=1.0);
	void setType(cubeType type = CUBE_WIREFRAME) { cubeType_ = type; };

private:
	float width_, height_, length_;
	float vertexCoord_[8][3];
	int index_[6][4];
	float normalCoord_[6][3];
	float textureCoord_[4][2];
	cubeType cubeType_;
};

}

#endif
