// material class
// -Kyoung Shin Park (2010 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __MATERIAL_H__
#define __MATERIAL_H__

#include "color.h"

namespace oglclass
{

class material
{
public:
    material(void);
    material(const color& ambientAndDiffuse);
    material(const color& ambientAndDiffuse, const color& specular,float shininess);

    void enable(void);
    void disable(void);
    
    void setAmbient(const float * ambient);
    void setAmbient(vector4& ambient);
    void setDiffuse(const float * diffuse);
    void setDiffuse(vector4& diffuse);
    void setAmbientAndDiffuse(const float * ambientAndDiffuse);
    void setAmbientAndDiffuse(vector4& ambientAndDiffuse);
    void setSpecular(const float * specular);
    void setSpecular(vector4& specular);
    void setEmission(const float * emission);
    void setEmission(vector4& emission);
    void setShininess(float shininess);
    
    float * ambient(void) { return ambient_; }
    float * diffuse(void) { return diffuse_; }
    float * specular(void) { return specular_; }
    float * emission(void) { return emission_; }
    float shininess(void) { return shininess_; }

private:
    float ambient_[4], diffuse_[4], specular_[4], emission_[4];
    float shininess_;
};

} // namespace

#endif
