// matrix transformation class
// -Kyoung Shin Park (2009 Spring)
//////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <stdlib.h>
#include <GL/gl.h>
#include "matrixtransform.h"

namespace oglclass
{

matrixtransform::matrixtransform(float m0, float m4, float  m8, float m12,
								 float m1, float m5, float  m9, float m13,
								 float m2, float m6, float m10, float m14,
								 float m3, float m7, float m11, float m15)
{
    m_[0] = m0; m_[4] = m4; m_[8]  = m8;  m_[12] = m12;
    m_[1] = m1; m_[5] = m5; m_[9]  = m9;  m_[13] = m13;
    m_[2] = m2; m_[6] = m6; m_[10] = m10; m_[14] = m14;
    m_[3] = m3; m_[7] = m7; m_[11] = m11; m_[15] = m15;
}

matrixtransform::matrixtransform(const matrix4x4& other)
{
    m_[0] = other[0]; m_[4] = other[4]; m_[8]  = other[8];  m_[12] = other[12];
    m_[1] = other[1]; m_[5] = other[5]; m_[9]  = other[9];  m_[13] = other[13];
    m_[2] = other[2]; m_[6] = other[6]; m_[10] = other[10]; m_[14] = other[14];
    m_[3] = other[3]; m_[7] = other[7]; m_[11] = other[11]; m_[15] = other[15];
}

void matrixtransform::multMatrix(void)
{
	glMultMatrixf(m_);
}

void matrixtransform::pushMatrix(void)
{
	glPushMatrix();
	glMultMatrixf(m_);
}

void matrixtransform::popMatrix(void)
{
	glPopMatrix();
}

void matrixtransform::setMatrix(const matrix4x4& m)
{
	memcpy(m_, (float*)m, sizeof(float)*16);
    /*m_[0] = m[0]; m_[4] = m[4]; m_[8]  = m[8];  m_[12] = m[12];
    m_[1] = m[1]; m_[5] = m[5]; m_[9]  = m[9];  m_[13] = m[13];
    m_[2] = m[2]; m_[6] = m[6]; m_[10] = m[10]; m_[14] = m[14];
    m_[3] = m[3]; m_[7] = m[7]; m_[11] = m[11]; m_[15] = m[15];*/
}

void matrixtransform::setMatrix(float * m)
{
	memcpy(m_, m, sizeof(float)*16);
    /*m_[0] = m[0]; m_[4] = m[4]; m_[8]  = m[8];  m_[12] = m[12];
    m_[1] = m[1]; m_[5] = m[5]; m_[9]  = m[9];  m_[13] = m[13];
    m_[2] = m[2]; m_[6] = m[6]; m_[10] = m[10]; m_[14] = m[14];
    m_[3] = m[3]; m_[7] = m[7]; m_[11] = m[11]; m_[15] = m[15];*/
}

} // namespace
