// node class
// -Kyoung Shin Park (2010 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __NODE_H__
#define __NODE_H__

#include "material.h"
#include "matrixtransform.h"
#include "transform.h"

namespace oglclass
{

class node 
{
public:
	typedef void (*CallbackFunc)(node&,void*);

	node(void);
	virtual ~node(void);

	void setMaterial(material * m) { material_ = m; }						// material
	material& getMaterial(void) const { return *material_; }
	void setMatrixTransform(matrixtransform * t) { matrixTransform_ = t; }	// matrixtransform
	matrixtransform& getMatrixTransform(void) const { return *matrixTransform_; }
	void setTransform(transform * t) { transform_ = t; }					// transform
	transform& getTransform(void) const { return *transform_; }

	void drawAll(void);
	void updateAll(void);
	virtual void draw(void);
	virtual void update(void);

	void addChild(node&);
	void removeChild(node&);
	int numChildren(void);
	node& getChild(int n);

	void setDrawCallback(CallbackFunc drawfunc,void *data=0);
	void setDrawCallbackData(void *data);
	void setUpdateCallback(CallbackFunc updatefunc,void *data=0);
	void setUpdateCallbackData(void *data);

private:
	material * material_;
	matrixtransform * matrixTransform_;
	transform * transform_;

	node * parent_;
	node ** children_;
	int numChildren_, maxChildren_;
	CallbackFunc drawFunc_, updateFunc_;
	void *drawData_, *updateData_;
};

}

#endif
