// transformation class
// -Kyoung Shin Park (2009 Spring)
//////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <GL/gl.h>
#include "transform.h"

namespace oglclass
{

transform::transform(void)
{
	setTranslation(0,0,0);
	setRotation(0,1,0,0);
	setScaling(1);
}

void transform::apply(void)
{
	glTranslatef(translate_[0], translate_[1], translate_[2]);
	glRotatef(rotateAngle_, rotateAxis_[0], rotateAxis_[1], rotateAxis_[2]);
	glScalef(scale_[0], scale_[1], scale_[2]);
}

void transform::pushMatrix(void)
{
	glPushMatrix();
	apply();
}

void transform::popMatrix(void)
{
	glPopMatrix();
}

void transform::setTranslation(vector3& trans) 
{
	translate_[0] = trans[0];
	translate_[1] = trans[1];
	translate_[2] = trans[2];
}

void transform::setTranslation(float x, float y, float z)
{
	translate_[0] = x;
	translate_[1] = y;
	translate_[2] = z;
}

void transform::setRotation(float angle, vector3& axis) 
{
	rotateAngle_ = angle;
	rotateAxis_[0] = axis[0];
	rotateAxis_[1] = axis[1];
	rotateAxis_[2] = axis[2];
}

void transform::setRotation(float angle, float x, float y, float z)
{
	rotateAngle_ = angle;
	rotateAxis_[0] = x;
	rotateAxis_[1] = y;
	rotateAxis_[2] = z;
}

void transform::setScaling(float s)
{
	scale_[0] = s;
	scale_[1] = s;
	scale_[2] = s;
}

void transform::setScaling(vector3& s)
{
	scale_[0] = s[0];
	scale_[1] = s[1];
	scale_[2] = s[2];
}

void transform::setScaling(float x, float y, float z)
{
	scale_[0] = x;
	scale_[1] = y;
	scale_[2] = z;
}

} // namespace
