// transformation class
// -Kyoung Shin Park (2009 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __TRANSFORM_H__
#define __TRANSFORM_H__

#include "vector3.h"

namespace oglclass
{

class transform
{
public:
	transform(void);
	void apply(void);
	void pushMatrix(void);
	void popMatrix(void);

	void setTranslation(vector3& trans);
	void setTranslation(float x, float y, float z);
	void setRotation(float angle, vector3& axis);
	void setRotation(float angle, float x, float y, float z);
	void setScaling(float s);
	void setScaling(vector3& s);
	void setScaling(float x, float y, float z);

	float * translation(void) { return translate_; }
	float rotationAngle(void) { return rotateAngle_; }
	float * rotationAxis(void) { return rotateAxis_; }
	float * scaling(void) { return scale_; }

private:
	float translate_[3];
	float rotateAngle_;
	float rotateAxis_[3];
	float scale_[3];
};

} // namespace

#endif
