// weed class
// -Kyoung Shin Park (2010 Spring)
//////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <GL/glu.h>
#include <GL/gl.h>
#include "weed.h"

namespace oglclass {

#define DEGTORAD(degree) ((degree) * (3.141592654f / 180.0f))
#define RADTODEG(radian) ((radian) * (180.0f / 3.141592654f))

weed::weed(void) : geometry()
{ 
	weedType_ = WEED_GRASS; 
}

weed::~weed()
{
}

void weed::draw()
{
	if(weedType_ == WEED_GRASS)
	{
		glScalef(0.3f, 0.3f, 0.3f);
		//glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, green);
		glPushMatrix();
			glRotatef(-90, 1, 0, 0);
			glPushMatrix();
				glTranslatef(0.5, 0, 0);
				glRotatef(15, 0, 1, 0);
				gluCylinder(quadric_, 0.25, 0.25, 0.75, 2, 1);
				glTranslatef(0, 0, 0.75);
				glRotatef(30, 0, 1, 0);
				gluCylinder(quadric_, 0.25, 0, 1.25, 2, 1);
			glPopMatrix();
			glPushMatrix();
				glTranslatef(0.37, 0, 0);
				glRotatef(-45, 0, 0, 1);
				glRotatef(-20, 0, 1, 0);
				gluCylinder(quadric_, 0.25, 0.25, 1.25, 2, 1);
				glTranslatef(0, 0, 1.25);
				glRotatef(-20, 0, 1, 0);
				gluCylinder(quadric_, 0.25, 0, 2, 2, 1);
			glPopMatrix();
			glPushMatrix();
				glTranslatef(0.37, 0, 0);
				glRotatef(60, 0, 0, 1);
				glRotatef(-10, 0, 1, 0);
				gluCylinder(quadric_, 0.25, 0.25, 1, 2, 1);
				glTranslatef(0, 0, 1);
				glRotatef(-40, 0, 1, 0);
				gluCylinder(quadric_, 0.25, 0, 1.75, 2, 1);
			glPopMatrix();
			glPushMatrix();
				glTranslatef(-2, 1, 0);
				gluCylinder(quadric_, 0.125, 0, 1, 2, 1);
				glRotatef(60, 0, 0, 1);
				glTranslatef(0.25, 0.75, 0);
				gluCylinder(quadric_, 0.125, 0, 1.25, 2, 1);
				glRotatef(30, 0, 0, 1);
				glTranslatef(0.25, -0.75, 0);
				gluCylinder(quadric_, 0.125, 0, 1, 2, 1);
				glRotatef(-120, 0, 0, 1);
				glTranslatef(0.5, -1.25, 0);
				gluCylinder(quadric_, 0.125, 0, 1.5, 2, 1);
				glRotatef(120, 0, 0, 1);
				glTranslatef(-0.75, 0.25, 0);
				gluCylinder(quadric_, 0.125, 0, 0.75, 2, 1);
				glRotatef(135, 0, 0, 1);
				glTranslatef(-3, 0, 0);
				gluCylinder(quadric_, 0.125, 0, 1.12, 2, 1);
			glPopMatrix();
		glPopMatrix();
	}
	else if(weedType_ == WEED_HERB)
	{
		//glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, green);
		glPushMatrix();
			glRotatef(60, 0, 0, 1);
			glRotatef(-90, 1, 0, 0);
			glScalef(0.3, 1, 1);
			gluCylinder(quadric_, 0.07, 0, 0.9, 6, 1);
			glTranslatef(0, 0, 0.4);
			glScalef(1, 0.3, 1);
			gluSphere(quadric_, 0.5, 2, 5);
		glPopMatrix();
		glPushMatrix();
			glRotatef(40, 0, 1, 0);
			glRotatef(-60, 0, 0, 1);
			glRotatef(-90, 1, 0, 0);
			glScalef(0.3, 1, 1);
			gluCylinder(quadric_, 0.06, 0, 0.8, 6, 1);
			glTranslatef(0, 0, 0.34);
			glScalef(1, 0.3, 1);
			gluSphere(quadric_, 0.46, 2, 5);
		glPopMatrix();
		glPushMatrix();
			glRotatef(90, 0, 1, 0);
			glRotatef(50, 0, 0, 1);
			glRotatef(-90, 1, 0, 0);
			glScalef(0.3, 1, 1);
			gluCylinder(quadric_, 0.06, 0, 0.7, 6, 1);
			glTranslatef(0, 0, 0.24);
			glScalef(1, 0.3, 1);
			gluSphere(quadric_, 0.46, 2, 5);
		glPopMatrix();
		glPushMatrix();
			glRotatef(-80, 0, 1, 0);
			glRotatef(40, 0, 0, 1);
			glRotatef(-90, 1, 0, 0);
			glScalef(0.3, 1, 1);
			gluCylinder(quadric_, 0.05, 0, 0.66, 6, 1);
			glTranslatef(0, 0, 0.26);
			glScalef(1, 0.3, 1);
			gluSphere(quadric_, 0.4, 2, 5);
		glPopMatrix();
		glPushMatrix();
			glRotatef(-30, 0, 0, 1);
			glRotatef(-90, 1, 0, 0);
			glScalef(0.3, 1, 1);
			gluCylinder(quadric_, 0.046, 0, 0.46, 6, 1);
			glTranslatef(0, 0, 0.18);
			glScalef(1, 0.3, 1);
			gluSphere(quadric_, 0.34, 2, 5);
		glPopMatrix();
		glPushMatrix();
			glRotatef(-30, 0, 1, 0);
			glRotatef(20, 0, 0, 1);
			glRotatef(-90, 1, 0, 0);
			glScalef(0.3, 1, 1);
			gluCylinder(quadric_, 0.046, 0, 0.46, 6, 1);
			glTranslatef(0, 0, 0.2);
			glScalef(1, 0.3, 1);
			gluSphere(quadric_, 0.26, 2, 5);
		glPopMatrix();
	}
	else if(weedType_ == WEED_BUSH)
	{
		glScalef(0.1f, 0.1f, 0.1f);
		//glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, gray);
		glPushMatrix();
			glRotatef(-90, 1, 0, 0);
			glTranslatef(0, 2, 0);
			gluCylinder(quadric_, 0.5, 0, 10, 5, 1);
			glTranslatef(3, -3, 0);
			gluCylinder(quadric_, 0.4, 0, 8, 5, 1);
			glTranslatef(-4, -1, 0);
			gluCylinder(quadric_, 0.5, 0, 10, 5, 1);
			glTranslatef(5, 6, 0);
			gluCylinder(quadric_, 0.4, 0, 8, 5, 1);
		glPopMatrix();
		glPushMatrix();
			GLfloat shear[] = {1,  0, 0, 0, tan(DEGTORAD(10)), 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1};
			glRotatef(120, 0, 1, 0);
			glMultMatrixf(shear);
			glRotatef(-90, 1, 0, 0);
			glTranslatef(0, 2, 0);
			gluCylinder(quadric_, 0.5, 0, 10, 5, 1);
			glTranslatef(3, -3, 0);
			gluCylinder(quadric_, 0.4, 0, 8, 5, 1);
			glTranslatef(-4, -1, 0);
			gluCylinder(quadric_, 0.5, 0, 10, 5, 1);
			glTranslatef(5, 6, 0);
			gluCylinder(quadric_, 0.4, 0, 8, 5, 1);
		glPopMatrix();
		glPushMatrix();
			glRotatef(240, 0, 1, 0);
			glMultMatrixf(shear);
			glRotatef(-90, 1, 0, 0);
			glTranslatef(0, 2, 0);
			gluCylinder(quadric_, 0.5, 0, 10, 5, 1);
			glTranslatef(3, -3, 0);
			gluCylinder(quadric_, 0.4, 0, 8, 5, 1);
			glTranslatef(-4, -1, 0);
			gluCylinder(quadric_, 0.5, 0, 10, 5, 1);
			glTranslatef(5, 6, 0);
			gluCylinder(quadric_, 0.4, 0, 8, 5, 1);
		glPopMatrix();
		//glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, green);
		glPushMatrix();
			glTranslatef(0, 4, 0);
			glRotatef(-90, 1, 0, 0);
			gluSphere(quadric_, 3, 3, 3);
			glTranslatef(-3, 3, 1);
			gluSphere(quadric_, 2, 4, 3);
			glTranslatef(-2, 2, -1);
			gluSphere(quadric_, 2.5, 5, 3);
			glTranslatef(6, 0, -1);
			gluSphere(quadric_, 4, 5, 4);
			glTranslatef(2, -5, 3);
			gluSphere(quadric_, 3, 6, 5);
			glTranslatef(-5, -2, -2);
			gluSphere(quadric_, 3.5, 6, 4);
			glTranslatef(3, -5, 2);
			gluSphere(quadric_, 2, 6, 4);
			glTranslatef(-4, 3, -1);
			gluCylinder(quadric_, 4, 0, 7, 6, 1);
			glTranslatef(-4, 3, -1);
			gluCylinder(quadric_, 4, 0, 7, 6, 1);
			glTranslatef(4, 5, -1);
			gluCylinder(quadric_, 5, 0, 4, 6, 1);
			glTranslatef(1, -1, 3);
			gluCylinder(quadric_, 4, 0, 8, 6, 1);
			glTranslatef(5, -1, -2);
			gluCylinder(quadric_, 4, 0, 8, 6, 1);
			glTranslatef(0, -4, -2);
			gluCylinder(quadric_, 4, 0, 8, 6, 1);
		glPopMatrix();
	}
}

} // namespace

